public inbox for gdb-patches@sourceware.org
 help / color / mirror / Atom feed
From: Pedro Alves <pedro@palves.net>
To: gdb-patches@sourceware.org
Subject: [PATCH 1/2] Autogenerate gdb/syscalls/linux-defaults.xml.in (groups) from strace sources
Date: Fri, 24 Feb 2023 23:26:49 +0000	[thread overview]
Message-ID: <20230224232650.4031472-2-pedro@palves.net> (raw)
In-Reply-To: <20230224232650.4031472-1-pedro@palves.net>

I noticed that "catch syscall group:process" doesn't catch clone3,
while it does catch clone.

The catch syscall group information is recorded in the
gdb/syscalls/linux-defaults.xml.in file, which says:

  <!-- The group field information was based on strace.  -->

So I looked at the strace sources, to confirm that clone3 is in fact
recorded in the "process" group there too, and to check what other
syscalls might be missing groups.

After some digging, I found that strace records the group info in C
arrays, with entries like:
...
[ 61] = { 4,	TP,		SEN(wait4),			"wait4"			},
[ 62] = { 2,	TS|TP,		SEN(kill),			"kill"			},
[ 63] = { 1,	0,		SEN(uname),			"uname"			},
...

You can see the current master's table for Linux x86-64 here:

  https://github.com/strace/strace/blob/e88e5e9ae6da68f22d15f9be3193b1412ac9aa02/src/linux/x86_64/syscallent.h

The column with TS|TP above is what defines each syscall's groups.  So
I wrote a script that extracts this information and generates
linux-defaults.xml.in.

Change-Id: I679d59d42fb2a914bf7a99e4c558e9696e5adff1
---
 gdb/syscalls/update-linux-defaults.sh | 95 +++++++++++++++++++++++++++
 1 file changed, 95 insertions(+)
 create mode 100755 gdb/syscalls/update-linux-defaults.sh

diff --git a/gdb/syscalls/update-linux-defaults.sh b/gdb/syscalls/update-linux-defaults.sh
new file mode 100755
index 00000000000..2c001aa3b8a
--- /dev/null
+++ b/gdb/syscalls/update-linux-defaults.sh
@@ -0,0 +1,95 @@
+#!/bin/sh
+
+# Copyright (C) 2023 Free Software Foundation, Inc.
+#
+# This file is part of GDB.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+# Used to generate linux-defaults.xml.in, like so:
+# $ ./update-linux-defaults.sh ~/strace.git
+
+if [ $# -lt 1 ]; then
+    echo "dir argument needed"
+    exit 1
+fi
+
+d="$1"
+shift
+
+if [ ! -d "$d" ]; then
+    echo "cannot find $d"
+    exit 1
+fi
+
+pre ()
+{
+    f="$1"
+
+    year=$(date +%Y)
+
+    cat <<EOF
+<?xml version="1.0"?>
+<!-- Copyright (C) 2009-$year Free Software Foundation, Inc.
+
+     Copying and distribution of this file, with or without modification,
+     are permitted in any medium without royalty provided the copyright
+     notice and this notice are preserved.  -->
+
+<!-- This file was generated using the sources from strace.  -->
+EOF
+
+    echo '<syscalls_defaults>'
+}
+
+
+post ()
+{
+    echo '</syscalls_defaults>'
+}
+
+generate ()
+{
+    f="$1"
+
+    pre "$f"
+
+    grep -rn -E "T[A-Z][,|]" "$d/src/linux/" \
+	| sed -e 's/\(T[A-Z][,|].*\)/\x03&/' -e 's/.*\x03//' \
+	      -e 's/,[ \t]*SEN[ \t]*(/, SEN(/g' \
+	| grep ", SEN(" \
+	| sed -e 's/\(.*\"\).*/\1/g' \
+	      -e 's/#64\"/\"/g' \
+	| awk '{print $3 " " $1}' \
+	| sort -u \
+	| sed -e 's/|/,/g' \
+	      -e 's/TD,/descriptor,/g' \
+	      -e 's/TF,/file,/g' \
+	      -e 's/TI,/ipc,/g' \
+	      -e 's/TM,/memory,/g' \
+	      -e 's/TN,/network,/g' \
+	      -e 's/TP,/process,/g' \
+	      -e 's/TS,/signal,/g' \
+	      -e 's/[A-Z]\+,//g' \
+	| grep -v '" $' \
+	| sed 's/,$//g' \
+	| awk "{printf \"  <syscall name=%s groups=\\\"%s\\\"/>\n\", \$1, \$2}"
+
+    post
+}
+
+f=linux-defaults.xml.in
+
+echo "Generating $f"
+generate "$t" > "$f"
-- 
2.36.0


  reply	other threads:[~2023-02-24 23:26 UTC|newest]

Thread overview: 7+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2023-02-24 23:26 [PATCH 0/2] Autogenerate gdb/syscalls/linux-defaults.xml.in (syscall groups) " Pedro Alves
2023-02-24 23:26 ` Pedro Alves [this message]
2023-02-25  3:00   ` [PATCH 1/2] Autogenerate gdb/syscalls/linux-defaults.xml.in (groups) " Simon Marchi
2023-02-27 15:04     ` Pedro Alves
2023-02-24 23:26 ` [PATCH 2/2] Regenerate Linux syscall group info Pedro Alves
2023-02-25  9:31 ` [PATCH 0/2] Autogenerate gdb/syscalls/linux-defaults.xml.in (syscall groups) from strace sources Tom de Vries
2023-02-27 14:53   ` Pedro Alves

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20230224232650.4031472-2-pedro@palves.net \
    --to=pedro@palves.net \
    --cc=gdb-patches@sourceware.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).